STATIC QR WORKSHOP
About QR Studio
QR Studio is a free QR code generator that runs entirely in your browser. It makes static codes that keep working for as long as they are readable, and it checks every design before you download it.
What QR Studio does
QR Studio turns ten kinds of content into QR codes: web addresses, Wi-Fi network details, contact cards (vCard), pre-filled emails, plain text, phone numbers, text messages, WhatsApp chats, map locations and calendar events. Each type has its own form with checks for common mistakes, such as a Wi-Fi password that is too short or an email address with a typo. You can change colours, module shapes and corner styles, add a logo and a short label, and download the result as a PNG image or a vector SVG.
How it works
When you open the generator, your browser downloads the page and a few small script files from this site. From then on, everything happens on your device. The content you type is turned into a QR code by a JavaScript encoder, drawn as vector shapes and shown in the preview. Every change triggers a scan check: the finished design is decoded again with the open-source jsQR reader at three different sizes, and you see a green tick only if the result matches your input exactly. The downloads are produced in the same way, without a round trip to a server.
That design is also why the site can be private. There are no accounts or advertising scripts. Cloudflare adds page performance analytics on the hosted domain; the app does not send your QR content to this beacon. Your Wi-Fi password, contact details and logo never leave the browser tab. See the privacy page for the details.
Static codes only
Every code QR Studio makes is static: the content is written into the code itself. A static code cannot be edited after printing and cannot count scans, but it also cannot be switched off. It does not depend on this website staying online, on a subscription or on anyone's redirect server.
Dynamic codes work differently. They contain a short link to the provider's server, which forwards the visitor to the real destination. That makes editing and scan statistics possible, and for some campaigns it is the right choice. The trade-off is that the code depends on the provider. One large provider's help centre, for example, states that dynamic codes created in its free trial are deactivated when the trial ends, while static codes keep working. QR Studio leaves that trade-off out entirely.
What QR Studio does not do
- No dynamic or editable codes, and no scan statistics.
- No file, image, video or form hosting — those need a server to store your content.
- No batch generation or QR code reading yet; both are planned.
Standards and open-source parts
- QR encoding uses the QR Code generator library by Kazuhiko Arase (MIT licence).
- The scan check uses jsQR (Apache License 2.0).
- Wi-Fi codes follow the widely supported
WIFI:format documented by the ZXing project, including its escaping rules. - Contact cards follow vCard 3.0 (RFC 2426), and email codes use
mailto:links as defined in RFC 6068. - Phone, SMS,
geo:and calendar codes use thetel:,SMSTO:,geo:andVEVENTforms listed by ZXing; event text is escaped as in iCalendar (RFC 5545). - WhatsApp codes use WhatsApp's documented
wa.meclick-to-chat links, and map links follow the formats documented by Google Maps and Apple Maps.
Both library licences are shipped with the site's files. Testing covers every content type at every error correction level and module shape, decoding each generated code back to its original content.
Feedback
QR Studio is a small independent project and is still being improved. If a code made here does not scan on your phone, the most useful details are the content type, the style settings you chose and the phone and app you scanned with.
Questions
Is QR Studio free?
Yes. There is no sign-up, no paid plan and no limit on the number of codes you make or how often they are scanned.
Do I need an account?
No. There are no accounts. Nothing you make is stored on a server, so there is nothing to log in to.
Will my codes stop working if this site goes offline?
No. The content is inside the code itself. A code you downloaded keeps working without this website.
Can I use the codes commercially?
Yes. The codes you make are yours to use on products, packaging, signs and marketing material.
Why is there no scan tracking?
Counting scans needs a redirect through a server, which would make your codes depend on that server. QR Studio makes static codes only.